
-- # import logic
-- # import nat

-- The accessibility predicate. Allows us to do well-founded induction over
-- natural numbers.
data Acc (n:Nat) : Prop where
  acc : ((m:Nat) -> m < n -> Acc m) -> Acc n

-- All natural numbers are accessible.
accessible : (n:Nat) -> Acc n
accessible  zero   = acc $ \m h -> falseE h
accessible (suc n) = step (accessible n)
  where
    rem (m : Nat) : Acc n -> (m < suc n) -> Acc m
    rem (acc h) (orIL "m<n") = h _ "m<n"
    rem (acc h) (orIR refl ) = acc h

    step : Acc n -> Acc (suc n)
    step a = acc $ \m "m<sn" -> rem a "m<sn"


