
-- # import nat
-- # import fin
-- # import vec
-- # import raw
-- # import type

{--------------------------------------------------------------------------
    Typed lambda terms
 --------------------------------------------------------------------------}

-- Contexts ---------------------------------------------------------------

Ctx : Nat -> Set
Ctx n = Vec Typ n 

-- Terms ------------------------------------------------------------------

infixl 20 @

data Term' : (n:Nat) -> Ctx n -> Typ -> Set where

  var (n:Nat)(ctx:Ctx n) : (i : Fin n) -> Term' n ctx (ctx!i)

  (@) (n:Nat)(ctx:Ctx n)(s,t:Typ) :
      Term' n ctx (s ==> t) -> Term' n ctx s -> Term' n ctx t

  lam (n:Nat)(ctx:Ctx n)(s,t:Typ) :
      Term' (suc n) (s :: ctx) t -> Term' n ctx (s ==> t)

Term (n:Nat) : Ctx n -> Typ -> Set
Term ctx t = Term' _ ctx t

{--------------------------------------------------------------------------
    Type erasure
 --------------------------------------------------------------------------}

erase (n:Nat)(ctx:Ctx n)(t:Typ) : Term ctx t -> RawTerm n
erase (var i)		  = rvar i
erase (e1 @ e2)		  = rapp (erase e1) (erase e2)
erase (lam {_} {_} {s} e) = rlam s (erase e)

