
infixl 10 +
infixr 9 ++, ::
infix 5 ==

data Nat : Set where
  zero : Nat
  suc  : Nat -> Nat

(+) : Nat -> Nat -> Nat
0     + m = m
suc n + m = suc (n + m)

data (==) {A:Set}(a:A) : A -> Set where
  refl : a == a

subst (A:Set)(x,y:A) : (P : A -> Set) -> x == y -> P x -> P y
subst P refl px = px

sym (A:Set)(x,y:A) : x == y -> y == x
sym refl = refl

plus0 : (n:Nat) -> n + 0 == n
plus0 0	      = refl
plus0 (suc n) = rewrite-plugin(plus0 n, refl)

plusS : (n,m:Nat) -> n + suc m == suc (n + m)
plusS 0 m	= refl
plusS (suc n) m = rewrite-plugin(plusS n m, refl)

data Vec (A:Set) : Nat -> Set where
  nil	       : Vec A 0
  (::) (n:Nat) : A -> Vec A n -> Vec A (suc n)

(++) (A:Set)(n,m:Nat) : Vec A n -> Vec A m -> Vec A (n + m)
[] ++ ys      = ys
(x::xs) ++ ys = x :: (xs ++ ys)

reverse (A:Set)(n:Nat) : Vec A n -> Vec A n
reverse {A} {p} xs = rewrite-plugin(sym (plus0 p), rev xs [])
  where
    rev (n,m:Nat) : Vec A n -> Vec A m -> Vec A (n + m)
    rev [] zs	   = zs
    rev {suc n} {m} (y::ys) zs = rewrite-plugin(sym (plusS n m), rev ys (y::zs))

